﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

//-----------------www.EasySoft.ir---------------
namespace EasySoft
{
    class Program
    {
        static StreamReader streamReader = new StreamReader("..//..//elimination_2014_problem_C.in");
        static StreamWriter streamWriter = new StreamWriter("..//..//elimination_2014_problem_C.out");

        static int[] dx = { -1, 0, 0, 1 };
        static int[] dy = { 0, 1, -1, 0 };
        static int oo = 2000000000;

        static void Main(string[] args)
        {
            int T = int.Parse(streamReader.ReadLine());
            for (int t = 0; t < T; t++)
            {
                streamReader.ReadLine();
                string[] str = streamReader.ReadLine().Split(' ');
                int n = int.Parse(str[0]);
                int m = int.Parse(str[1]);

                int[,] map = new int[n, m];

                for (int i = 0; i < n; i++)
                {
                    str = streamReader.ReadLine().Split(' ');
                    for (int j = 0; j < m; j++)
                    {
                        map[i, j] = int.Parse(str[j]);
                    }
                }

                bool res = true;
                LinkedList<int> queue = new LinkedList<int>();

                for (int si = 0; si < n; si++)
                {
                    for (int sj = 0; sj < m; sj++)
                    {
                        bool[, ,] visited = new bool[n, m, 2];
                        int[, ,] best = new int[n, m, 2];

                        for (int i = 0; i < n; i++)
                        {
                            for (int j = 0; j < m; j++)
                            {
                                for (int k = 0; k < 2; k++)
                                {
                                    best[i, j, k] = oo;
                                }
                            }
                        }

                        int nx = -1, ny = -1;
                        for (int i = 0; i < n; i++)
                        {
                            for (int j = 0; j < m; j++)
                            {
                                if (i != si || j != sj)
                                {
                                    if (map[si, sj] == map[i, j])
                                    {
                                        res = false;
                                    }
                                    if (map[i, j] < map[si, sj] && (nx == -1 || map[nx, ny] < map[i, j]))
                                    {
                                        nx = i;
                                        ny = j;
                                    }
                                }
                            }
                        }
                        if (!res)
                        {
                            si = n;
                            break;
                        }
                        if (nx == -1)
                        {
                            continue;
                        }

                        visited[si, sj, map[si, sj] % 2] = true;
                        best[si, sj, map[si, sj] % 2] = 0;

                        queue.Clear();

                        queue.AddLast(si);
                        queue.AddLast(sj);
                        queue.AddLast(map[si, sj] % 2);

                        while (queue.Count != 0)
                        {
                            int ax = queue.First.Value;
                            queue.RemoveFirst();

                            int ay = queue.First.Value;
                            queue.RemoveFirst();
                            
                            int am = queue.First.Value;
                            queue.RemoveFirst();

                            if (ax == nx && ay == ny)
                            {
                                continue;
                            }

                            for (int d = 0; d < 4; d++)
                            {
                                int tx = ax + dx[d];
                                int ty = ay + dy[d];
                                int tm = 1 - am;

                                if (tx < 0 || ty < 0 || tx >= n || ty >= m)
                                {
                                    continue;
                                }
                                if (visited[tx, ty, tm])
                                {
                                    continue;
                                }
                                if (map[tx, ty] < map[nx, ny])
                                {
                                    continue;
                                }

                                visited[tx, ty, tm] = true;
                                best[tx, ty, tm] = 1 + best[ax, ay, am];

                                queue.AddLast(tx);
                                queue.AddLast(ty);
                                queue.AddLast(tm);
                            }
                        }

                        if (!(map[si, sj] - best[nx, ny, map[nx, ny] % 2] >= map[nx, ny]))
                        {
                            res = false;
                            si = n;
                            break;
                        }

                        bool ok = false;
                        for (int d = 0; d < 4; d++)
                        {
                            int tx = dx[d] + si;
                            int ty = dy[d] + sj;

                            if (tx < 0 || ty < 0 || tx >= n || ty >= m)
                            {
                                continue;
                            }

                            if (map[tx, ty] > map[si, sj])
                            {
                                ok = true;
                            }
                        }

                        if (!ok && map[si, sj] - best[nx, ny, map[nx, ny] % 2] != map[nx, ny])
                        {
                            res = false;
                            si = n;
                            break;
                        }
                    }
                }

                streamWriter.WriteLine("Case #" + (t + 1).ToString() + ":");
                if(res)
				{
					streamWriter.WriteLine("YES");
				}
				else
				{
                    streamWriter.WriteLine("NO");
				}
            }

            streamReader.Close();
            streamWriter.Close();
        }
    }
}
